<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2013 IMIA net based solutions (d.frerich@imia.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

namespace IMIA\BaseExt\Utility;

/**
 * @package     imia_base
 * @subpackage  Utility
 * @author      David Frerich <d.frerich@imia.de>
 */
class ExtensionUtility
{
    /**
     * @param string $extKey
     * @param string $name
     * @param string $path
     * @param string $label
     */
    static public function registerPageIcon($extKey, $name, $path, $label = null)
    {
        $iconPath = \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath($extKey) . $path;

        $GLOBALS['TCA']['pages']['columns']['module']['config']['items'][] = array($label ?: $name, $name, $iconPath);
        \TYPO3\CMS\Backend\Sprite\SpriteManager::addTcaTypeIcon('pages', 'contains-' . $name, $iconPath);
    }

    /**
     * @param string $extKey
     * @param string $pluginName
     * @param string $path
     */
    static public function registerPluginFlexform($extKey, $pluginName, $path)
    {
        $extensionName = str_replace(' ', '', ucwords(str_replace('_', ' ', $extKey)));
        $pluginSignature = strtolower($extensionName) . '_' . strtolower($pluginName);

        $GLOBALS['TCA']['tt_content']['types']['list']['subtypes_excludelist'][$pluginSignature] = 'layout,select_key,recursive,pages';
        $GLOBALS['TCA']['tt_content']['types']['list']['subtypes_addlist'][$pluginSignature] = 'pi_flexform';

        \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPiFlexFormValue($pluginSignature,
            'FILE:EXT:' . $extKey . '/' . $path);
    }

    /**
     * @param string $extKey
     * @param string $name
     * @param string $path
     * @param string $afterPosition
     */
    static public function registerModuleGroup($extKey, $name, $path = 'Configuration/Module/', $afterPosition = 'file')
    {
        \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addModule($name, '', '',
            \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($extKey) . $path);

        if (isset($GLOBALS['TBE_MODULES'][$afterPosition]) ){
            $extModConf = $GLOBALS['TBE_MODULES'][$name];
            unset($GLOBALS['TBE_MODULES'][$name]);
        }

        $tempBeModules = array();
        foreach ($GLOBALS['TBE_MODULES'] as $key => $value) {
            $tempBeModules[$key] = $value;
            if ($key == $afterPosition){
                $tempBeModules[$name] = $extModConf;
            }
        }

        $GLOBALS['TBE_MODULES'] = $tempBeModules;
    }
}